mapW,mapH = 9,9

maxMines = 10

dirs = {{x=1,y=1},{x=0,y=1},{x=-1,y=1},{x=-1,y=0},{x=-1,y=-1},{x=0,y=-1},{x=1,y=-1},{x=1,y=0}}

function gameInit()
  mineMap = newArr(mapW,mapH,false)
  mines = {}

  numberMap = newArr(mapW,mapH,0)

  revealedMap = newArr(mapW,mapH,false)
  revealedCount = 0

  flagMap = newArr(mapW,mapH,0)
  flagCount = 0

  state = "game"

  pressed = {x=0,y=0}
end

function reveal(x,y)
  if not revealedMap[y][x] then
    revealedMap[y][x] = true
    revealedCount = revealedCount + 1
    if revealedCount >= mapW*mapH-maxMines then
      state = "win"
      faceBtn.img = "win"
      timeRunning = false
      for _,m in ipairs(mines) do
        flagMap[m.y][m.x] = 1
      end
    end
  end
end

function genMines(nx,ny)
  local freeSpaces = {}
  for x=1,mapW do
    for y=1,mapH do
      if nx ~= x or ny ~= y then
        table.insert(freeSpaces,{x=x,y=y})
      end
    end
  end
  for i=1,maxMines do
    local ind = math.random(1,#freeSpaces)
    local c = freeSpaces[ind]
    mineMap[c.y][c.x] = true
    table.insert(mines,{x=c.x,y=c.y})
    table.remove(freeSpaces,ind)
  end
  for x=1,mapW do
    for y=1,mapH do
      local n = 0
      for _,d in ipairs(dirs) do
        local tx,ty = x+d.x,y+d.y
        if tx >= 1 and tx <= mapW and ty >= 1 and ty <= mapH then
          if mineMap[ty][tx] then
            n = n + 1
          end
        end
      end
      if not mineMap[y][x] then
        numberMap[y][x] = n
      end
    end
  end
end

function click(x,y)
  if not revealedMap[y][x] and flagMap[y][x] == 0 then
    if mineMap[y][x] then
      state = "lose"
      timeRunning = false
      for _,m in ipairs(mines) do
        if flagMap[m.y][m.x] ~= 1 then
          reveal(m.x,m.y)
        end
      end
      faceBtn.img = "gameover"
    elseif numberMap[y][x] > 0 then
      reveal(x,y)
    else
      local fills = floodFill(numberMap,x,y,0)
      for _,f in ipairs(fills) do
        reveal(f.x,f.y)
        flagMap[f.y][f.x] = 0
        for _,d in ipairs(dirs) do
          local tx,ty = f.x+d.x,f.y+d.y
          if tx >= 1 and tx <= mapW and ty >= 1 and ty <= mapH then
            if numberMap[ty][tx] > 0 then
              reveal(tx,ty)
              flagMap[ty][tx] = 0
            elseif numberMap[ty][tx] == 0 and not mineMap[ty][tx] then
              click(tx,ty)
            end
          end
        end
      end
    end
  end
end