function love.load(arg)
  math.randomseed(os.time())
  
  love.graphics.setDefaultFilter("nearest","nearest")

  require "utils"

  require "tiles"

  require "floodFill"

  require "game"

  require "bevel"

  require "board"

  require "face"

  require "counter"
  
  love.window.setMode(mapW*ts+17,mapH*ts+60)
  
  screenW,screenH = love.graphics.getDimensions()
  
  flagCounterPos = {x=15,y=14}
  timeCounterPos = {x=screenW-14-(digitW+digitMargin)*3,y=13}
  
  faceBtn.x = math.ceil(screenW/2-faceBtn.w/2)
  
  topBox = {x=8,y=8,w=screenW-15,h=33,s=2}
  
  love.graphics.setBackgroundColor(unpack(bevelc2))
  
  started = false
  
  startTime = 0
  timeCount = 0
  timeRunning = false
  
  gameInit()
end

function love.mousepressed(x,y,b)
  local tx,ty = math.ceil((x-board.x)/ts),math.ceil((y-board.y)/ts)
  if tx >= 1 and tx <= mapW and ty >= 1 and ty <= mapH and state == "game" then
    if b == 1 or b == 3 and flagMap[ty][tx] ~= 1 then
      pressed.x,pressed.y = tx,ty
    elseif b == 2 and not love.mouse.isDown(1) and not revealedMap[ty][tx] then
      local oldFlag = flagMap[ty][tx]
      flagMap[ty][tx] = flagMap[ty][tx] + 1
      if flagMap[ty][tx] > 2 then
        flagMap[ty][tx] = 0
      end
      if flagMap[ty][tx] == 1 then flagCount = flagCount + 1 elseif flagMap[ty][tx] == 2 then flagCount = flagCount - 1 end
    end
  end
  if x >= faceBtn.x and x <= faceBtn.x + faceBtn.w and y >= faceBtn.y and y <= faceBtn.y + faceBtn.h then
    faceBtn.pressed = true
  elseif (b == 1 or b == 3) and not(x >= faceBtn.x and x <= faceBtn.x + faceBtn.w and y >= faceBtn.y and y <= faceBtn.y + faceBtn.h) and state == "game" and not faceBtn.pressed then
    faceBtn.img = "careful"
  end
end

function love.mousereleased(x,y,b)
  local tx,ty = math.ceil((x-board.x)/ts),math.ceil((y-board.y)/ts)
  --pressed.x,pressed.y = 0,0
  if state == "game" then
    faceBtn.img = "normal"
  end
  if x >= faceBtn.x and x <= faceBtn.x + faceBtn.w and y >= faceBtn.y and y <= faceBtn.y + faceBtn.h then
    gameInit()
    started = false
    --genMines()
    faceBtn.img = "normal"
    timeCount = 0
  end
  if tx >= 1 and tx <= mapW and ty >= 1 and ty <= mapH and state == "game" and not faceBtn.pressed then
    if b == 1 then
      if not started then
        genMines(tx,ty)
        started = true
        startTime = love.timer.getTime()
        timeRunning = true
      end
      click(tx,ty)
    end
  end
  faceBtn.pressed = false
end

function love.mousemoved(x,y,dx,dy)
  local tx,ty = math.ceil((x-board.x)/ts),math.ceil((y-board.y)/ts)
  if love.mouse.isDown(1,3) and state == "game" and not faceBtn.pressed then
    pressed.x,pressed.y = tx,ty
  end
  if not(x >= faceBtn.x and x <= faceBtn.x + faceBtn.w and y >= faceBtn.y and y <= faceBtn.y + faceBtn.h) then
    faceBtn.pressed = false
  end
end

function love.update(dt)
  if timeRunning and timeCount < 999 then
    timeCount = math.ceil(love.timer.getTime() - startTime)
  end
end

function love.draw()
  drawBoard(3,3)
  bevelBox(topBox.x,topBox.y,topBox.w,topBox.h,topBox.s)
  drawFaceBtn()
  drawCounter(maxMines-flagCount,3,flagCounterPos.x,flagCounterPos.y)
  drawCounter(timeCount,3,timeCounterPos.x,timeCounterPos.y)
end